<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Addon Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Addons
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Addon extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Addon()
  {
    parent::__construct();
    $this->load->helper('url');
	$this->load->library('session');
    $this->load->library('form_validation');
    $this->load->helper('form');
	$this->load->model('addon_model');
	if($_SERVER['REMOTE_ADDR'] != "::1")
	{
	    if (!$this->session->userdata('admin'))
	    {
	        redirect('/pages/dashboard/');
	    }
	}
  }
  
   // --------------------------------------------------------------------

   /**
	* Load main page
	*
	* @access	public
	* @return	view
	*/
  function index()
  {
    $this->load->view('home/settings/addon');
  }
  
   // --------------------------------------------------------------------

   /**
	* SmartEnergyGroup information controller
	*
	* @access	public
	* @return	view
	*/
  function seg()
  {
  	// Expected values
  	$this->form_validation->set_rules('site_key', 'Site Token',  'required');
  	$this->form_validation->set_rules('enabled', 'Enabled');
    
    if($this->form_validation->run() == FALSE)
    {
      $addon = $this->addon_model->GetAddon("SmartEnergyGroups");
	  
	  // Get the add-on information if set, if not set it to null
	  if($addon->num_rows() > 0)
	  {
		  $addon = $addon->row_array();
		  
		  $enable = $this->addon_model->GetAddonVar("enabled", $addon['addon_id']);
		  
		  if($enable->num_rows > 0)
		  {
		  	$enable = $enable->row_array();
		  	$data['enabled'] = $enable['value'];
			
		  	$key = $this->addon_model->GetAddonVar("key", $addon['addon_id']);
		  	$key = $key->row_array();
		  	$data['site_key'] = $key['value'];
		  }
		  else
		  {
		  	$data['enabled'] = '';
		  	$data['site_key'] = '';
		  }
	  }
	  else {
		  $data['enabled'] = '';
		  $data['site_key'] = '';
	  }
	  
      $this->load->view('home/settings/addon/seg', $data);  
    }
    else
    {
    	// If add-on exists, update it, if not add it
		$addon = $this->addon_model->GetAddon("SmartEnergyGroups");
		if($addon->num_rows() > 0)
		{
			$addon = $addon->row_array();
		  	$this->addon_model->UpdateAddonVar($addon['addon_id'], "key", set_value('site_key'));
		  	$this->addon_model->UpdateAddonVar($addon['addon_id'], "enabled", set_value('enabled'));
		  	$this->addon_model->UpdateAddonVar($addon['addon_id'], "date", 0);
		}
		else
		{
			$this->addon_model->InsertAddon("SmartEnergyGroups");
			$addon = $this->addon_model->GetAddon("SmartEnergyGroups");
			$addon = $addon->row_array();
		  	$this->addon_model->InsertAddonVar($addon['addon_id'], "key", set_value('site_key'));
		  	$this->addon_model->InsertAddonVar($addon['addon_id'], "enabled", set_value('enabled'));
		  	$this->addon_model->InsertAddonVar($addon['addon_id'], "date", 0);
		}
		
		redirect('pages/addon/seg');
    }
  }
}

