<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Billing Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Billing
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Billing extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Billing()
  {
    parent::__construct();
    $this->load->model('sysinfo_model');
    $this->load->helper('form');
    $this->load->library('form_validation');
    $this->load->helper('url');
	$this->load->library('session');
	if($_SERVER['REMOTE_ADDR'] != "::1")
	{
	    if (!$this->session->userdata('admin'))
	    {
	        redirect('/pages/loads/');
	    }
	}
  }
  
   // --------------------------------------------------------------------

   /**
	* Load main billing page
	*
	* @access	public
	* @return	view
	*/
  function index()
  {
    $this->load->view('home/settings/bill/index');
  }
  
   // --------------------------------------------------------------------

   /**
	* Flat billing controller
	*
	* @access	public
	* @return	view
	*/
  function Flat()
  {
  	// Expected values
    $this->form_validation->set_rules('flat', 'Flat Rate',  'required|max_length[10]');
    $this->form_validation->set_rules('start', 'Start of Month',  'required|max_length[2]');
    
    if($this->form_validation->run() == FALSE)
    {
    	// Get the current flat billing information
        $rate = $this->sysinfo_model->getBillingInfo();
        $rate = $rate->row_array();
        
        $data['flat'] = $rate['flat_rate'];
        $data['start'] = $rate['month_start'];
      
        $this->load->view('home/settings/bill/flat',$data);
    }
    else
    {
    	// Update the flat billing information
        $this->sysinfo_model->UpdateBilling(set_value('flat'), set_value('start'), 1);
        $data['flat'] = set_value('flat');
        $data['start'] = set_value('start');
		$data['msg'] = 'Your settings have been saved.';
      
        $this->load->view('home/settings/bill/flat',$data);
    }
    
  }

}