<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * ClearDB Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Database
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Cleardb extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Cleardb()
  {
    parent::__construct();
    $this->load->model('sysinfo_model');
	$this->load->model('minute_model');
	$this->load->model('hour_model');
	$this->load->model('device_model');
	$this->load->model('virtual_model');
	$this->load->model('channels_model');
    $this->load->helper('form');
    $this->load->library('form_validation');
    $this->load->helper('url');
	$this->load->library('session');
	if($_SERVER['REMOTE_ADDR'] != "::1")
	{
	    if (!$this->session->userdata('admin'))
	    {
	        redirect('/pages/dashboard/');
	    }
	}
  }
  
   // --------------------------------------------------------------------

   /**
	* Database clearing
	*
	* @access	public
	* @return	view
	*/
  function clear($msg = "")
  {
    $this->form_validation->set_rules('delete', 'Level of Deletion',  'required');
    
    if($this->form_validation->run() == FALSE)
    {
      $data['msg'] = $msg;	  
      $this->load->view('home/settings/cleardb',$data);
    }
    else
    {
      $sysinfo = $this->sysinfo_model->GetInfo();
      $sysinfo = $sysinfo->row_array();
	  
      // Dates to update database with
      date_default_timezone_set($sysinfo["timezone"]);
	  $now = gmdate('Y-m-d H:i:s');
	  $minDate = gmdate('Y-m-d H:i:00');
	  $hourDate = gmdate('Y-m-d H:00:00');
      
      
      if(set_value('delete') == 1)  // Clear Minute data
	  {
	  	$this->minute_model->ClearData();
		$this->device_model->setMinDate($minDate);
		$this->device_model->setGranDate($now);
	  }
	  
	  if(set_value('delete') == 2) // Clear Hour data
	  {
	  	$this->hour_model->ClearData();
		$this->device_model->setHourDate($hourDate);
	  }
	  
      if(set_value('delete')  == 3 || set_value('delete')  == 4)  // Clear all channels
	  {
	  	 $this->minute_model->ClearData();
	  	 $this->hour_model->ClearData();
		 $this->channels_model->ClearData();	
		 $this->virtual_model->ClearData();
		 $this->device_model->setHourDate($hourDate);
		 $this->device_model->setMinDate($minDate);
		 $this->device_model->setGranDate($now);
	  }
	  
	  if(set_value('delete') == 4)  // Clear all devices
	  {
	  	 $this->device_model->ClearData();
	  }
	  
	  redirect('/pages/cleardb/clear/1');
    }
  }
}