<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Devices Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Devices
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Devices extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Devices()
  {
    parent::__construct();
    $this->load->library('form_validation');
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->model('device_model');
    $this->load->model('channels_model');
	$this->load->library('session');
	if($_SERVER['REMOTE_ADDR'] != "::1")
	{
	    if (!$this->session->userdata('admin'))
	    {
	        redirect('/pages/loads/');
	    }
	}
  }
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function index()
  {
    $ecm = $this->device_model->getDevices('ecm1240');
    $geye = $this->device_model->getDevices('geye');
        
    $data['ecm'] = $ecm;
    $data['geye'] = $geye;
    
    $this->load->view('home/settings/devices', $data);
  }
}

