<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Firstrun Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Setup
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Firstrun extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Firstrun()
  {
    parent::__construct();
    $this->load->model('sysinfo_model');
    $this->load->model('module_model');
    $this->load->helper('url');
    $this->load->helper('form');
    $this->load->library('form_validation');
  }
  
   // --------------------------------------------------------------------

   /**
	* Insert initial information needed before data logging
	*
	* @access	public
	* @return	view
	*/
  function index()
  {
    $this->form_validation->set_rules('admin_user', 'Username',  'required|min_length[1]|max_length[25]');
    $this->form_validation->set_rules('admin_pass', 'Password',  'required');
    $this->form_validation->set_rules('admin_confpass', 'Password Confirmation',  'required');
    $this->form_validation->set_rules('timezone', 'Timezone',  'required');
    $this->form_validation->set_rules('locale', 'Locale',  'required');
    $this->form_validation->set_rules('admin_agree', 'License Agreement',  'required');
    if($this->form_validation->run() == FALSE)
    {
      $info = $this->sysinfo_model->GetInfo();
      $this->load->view('firstrun/index');  
    }
    else
    {
      $this->sysinfo_model->InsertInfo(set_value('locale'),set_value('timezone'),set_value('admin_user'),set_value('admin_pass'), "");
	  
	  redirect('/');
    }
  }
}