<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Images Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Images
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Images extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Images()
  {
    parent::__construct();
    $this->load->model('channelimage_model');
	$this->load->helper('url');
	$this->load->library('session');
    $this->load->helper('form');
	if($_SERVER['REMOTE_ADDR'] != "::1")
	{
	    if (!$this->session->userdata('admin'))
	    {
	        redirect('/pages/loads/');
	    }
	}
  }

   // --------------------------------------------------------------------

   /**
	* Show the images for channels
	*
	* @access	public
	* @return	void
	*/
  function index()
  {
	$images = $this->channelimage_model->GetImages();
	
	$data['images'] = $images;
	$data['type'] = $image_type;
	
	$this->load->view('home/settings/manageimage', $data);
  }
  
   // --------------------------------------------------------------------

   /**
	* Upload an image
	*
	* @access	public
	* @return	void
	*/
  function UploadImage($type, $id = 0)
  {	
  	$config['upload_path'] = './img/devices';
    $config['allowed_types'] = 'png|jpg|jpeg|gif';
    $config['max_size']    = 8000;
	$config['max_width']  = 400;
	$config['max_height']  = 400;
	$config['max_filename'] = 25;
	$config['overwrite'] = true;
	
    $this->load->library('upload', $config);

    if (!$this->upload->do_upload('userfile'))
    {
      	$data['error'] = $this->upload->display_errors();
    	if($id != 0)
		{
  			$data['link'] = 'pages/device/ecm1240/'.$id;
	  		$this->load->view('home/settings/imageupload', $data);
		}
		else
		{
			$this->session->set_flashdata('error', $data['error']);
			redirect('pages/images/');
		}
    }
    else
    {
      $upload_data = $this->upload->data();
	  $this->channelimage_model->InsertImage($upload_data['file_name']);
	  if($id != 0)
	  {
		 redirect('pages/device/ecm1240/');
	  }
	  else
	  {
	  	redirect('pages/images/');
	  }
    }
  }

   // --------------------------------------------------------------------

   /**
	* Delete an image
	*
	* @access	public
	* @return	void
	*/
  function RemoveImage($image_id, $type)
  {
	$img = $this->channelimage_model->GetImageByID($image_id);
	$img = $img->row_array();
	
	unlink('./img/devices/'.$img['image_name']); 
	$this->channelimage_model->RemoveImage($image_id, $img['image_name']);
	
	$data['msg'] = 'removed';
    $this->load->view('home/settings/imagecomplete', $data);  
  }
}
		