<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Loads Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Display
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Loads extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Loads()
  {
    parent::__construct();
    $this->load->helper('url');
    $this->load->helper('form');
    $this->load->model('sysinfo_model');
    $this->load->model('device_model');
  }
  
   // --------------------------------------------------------------------

   /**
	* Generate and display a list of devices 
	*
	* @access	public
	* @return	view
	*/
  function index()
  {
    $info = $this->sysinfo_model->GetInfo();

	if($info->num_rows() == 0)
	{
	 	redirect('/pages/firstrun');
	}
	
	$data['dev']  = $this->device_model->getDevices();
	
	// Redirect to the device if there's only 1 device
	if($data['dev']->num_rows() == 1)
	{
		$device = $data['dev']->row_array();
		redirect('pages/search/device/'.$device['device_id']);
	}
    $this->load->view('home/loads/index', $data);
  }
}