<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Search Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Display
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Search extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function Search()
  {
    parent::__construct();
    $this->load->helper('url');
    $this->load->helper('form');
    $this->load->model('channels_model');
	$this->load->model('minute_model');
	$this->load->model('sysinfo_model');
	$this->load->model('device_model');
	$this->load->model('hour_model');
  }
    
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function index()
  {
    $sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
  	$begin = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m") , date("d")-1, date("Y")));
    $end = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m") , date("d"), date("Y")));
    
	$search = set_value('search');
    $channels = $this->channels_model->channelSearch($search);
	$watt[0] = 0;
	
	/*if($channels->num_rows() > 0)
	{
	    $wattVals = $this->minute_model->getLastChannels($channels, $begin, $end);
		$x = 0;
		
		if($wattVals->num_rows() > 0)
		{
			foreach($wattVals->result() as $wattVal)
			{
				$watt[$x] = $wattVal->watt;
				
				$x++;
			}
		}
		else {
			foreach($channels->result() as $channel)
			{
				$watt[$x] = "-";
				
				$x++;
			}
		}
	}*/
	$data['watts'] = array();
    $data['channels'] = $channels;
    $this->load->view('home/loads/search', $data);
  }
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function device($dev_id)
  {
    $sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
  	$begin = gmdate('Y-m-d H:i:s', mktime(date("H"), date("i")-2, date("s"), date("m") , date("d"), date("Y")));
  	if($dev_id != 0)
	{
	    $channels = $this->channels_model->getDeviceChannels($dev_id);
	    $dev = $this->device_model->getSerial($dev_id);
		$dev = $dev->row_array();
		
		$data['dev'] = $dev;
	}
	else {
		$channels = $this->channels_model->getChannels();
	}
	
	$x = 0;
	$watt = array();
	foreach($channels->result() as $channel)
	{
		$watt[$x] = 0;
		$wattVal = $this->minute_model->getLastReading($channel->channel_id, $begin)->row_array();
		if(isset($wattVal['watt']))
		{
			$watt[$x] = $wattVal['watt'];
		}
		
		$x++;
	}
	$data['watts'] = $watt;
    $data['channels'] = $channels;
	$data['dev_id'] = $dev_id;
    $this->load->view('home/loads/device', $data);
  }
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function summary($dev_id)
  {
    $sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
  	$begin = gmdate('Y-m-d H:i:s', mktime(date("H"), date("i")-2, date("s"), date("m") , date("d"), date("Y")));
  	if($dev_id != 0)
	{
	    $channels = $this->channels_model->getDeviceChannels($dev_id);
	    $dev = $this->device_model->getSerial($dev_id);
		$dev = $dev->row_array();
		
		$data['dev'] = $dev;
	}
	else {
		$channels = $this->channels_model->getChannels();
	}
	
	$data['dev_id'] = $dev_id;
    $this->load->view('home/loads/devsum', $data);
  }
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function sumPie($dev_id, $type)
  {
    $sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
    if($type == 0)
    {
      $beginDate = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m") , date("d")-1, date("Y")));
      $end = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m") , date("d"), date("Y")));
    } 
    elseif($type == 1)
    {
      $start = mktime(0, 0, 0, date('m'), date('d')-date('w')+1, date('Y'));
      $beginDate = gmdate('Y-m-d H:i:s', $start);
      $end = gmdate('Y-m-d H:i:s', $start + (7 * 24*60*60));
    }
    elseif($type == 2)
    {
      $beginDate = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m"), 1, date("Y")));
      $end = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m")+1, 0, date("Y")));
    }
    else
    {
      $beginDate = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, 1, 1, date("Y")));
      $end = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, 12, 31, date("Y")));
    }
	
    $baseColour = 555555;
   
    if($dev_id != 0)
	{
	    $channels = $this->channels_model->getDeviceChannels($dev_id,0,-1,0);
	}
	else {
		$channels = $this->channels_model->getChannels();
	}
	
	
    $html = '[';
	$firstRec = TRUE;
	foreach($channels->result() as $channel)
	{
		
		if($type < 2)
		{	
			$powerUsed = $this->minute_model->getSumKwh($beginDate, $end, $channel->channel_id);
		}
		else
		{
			$powerUsed = $this->hour_model->getSumKwh($beginDate, $end, $channel->channel_id);
		}

		if($powerUsed->num_rows() > 0)
		{
			$powerUsed = $powerUsed->row_array();
			$powerUsed = round($powerUsed['kwh'],3);
		}
		else
		{
			$powerUsed = 0;
		}

		if(!$firstRec)
		{
			$html .= ', ';
		}
		else
		{
			$firstRec = FALSE;
		}
		
		if($channel->colour == "")
		{
			$channel->colour = $baseColour+202;
		}
		
	    $html .= '{ "channel":"'.$channel->channel_name.'", "colour": "#'.$channel->colour.'", "kwh":'.$powerUsed.' }';
	}
	
    
	$html .= ']';
	$data['html'] = $html;
    $this->load->view('graphs/index', $data);
  }
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function Line($dev_id)
  {
	if($dev_id != 0)
	{
    	$channels = $this->channels_model->getDeviceChannels($dev_id);
    	$dev = $this->device_model->getSerial($dev_id);
		$dev = $dev->row_array();
		
		$data['dev'] = $dev;
	}
	else
	{
		$channels = $this->channels_model->getChannels();
	}
	
	if($channels->num_rows() < 15)
	{
		$data['chart_height'] = "550px";
	}
	else if($channels->num_rows() > 15)
	{
		$data['chart_height'] = "750px";
	}
	else {
		$data['chart_height'] = "950px";
	}
	
    $sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    date_default_timezone_set($sys["timezone"]);
    
	$data['today'] = date('m/d/Y', mktime(0, 0, 0, date("m") , date("d"), date("Y")));
	
	$data['dev_id'] = $dev_id;
		
    $this->load->view('home/loads/devline', $data);
  }
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function Live($dev_id = 0)
  {
	$sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
    $theDate = date("Y-m-d",time());
	$userTimezone = new DateTime($theDate, new DateTimeZone($sys['timezone']));
  	$offset = $userTimezone->getOffset();
	
    $begin = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m") , (date("d")-1), date("Y")));
   	$end = date('Y-m-d H:i:s', strtotime('+24 hours', strtotime($begin)));
	
	$chanGraph = '<table id="Table" style="width:400px;"><tr>
		    	<th>Channel Name</th>
		    	<th>Watts</th>
		    	<th>Todays kWh</th>
			</tr>';
	if($dev_id == 0)
	{
		$dev = $this->device_model->getDevices();
	}
	else
	{
		$dev = $this->device_model->getSerial($dev_id);
	}
	$chart_height = 0;
	foreach($dev->result() as $device)
	{
		$channels = $this->minute_model->GetSumPowerReal($begin, $end, $dev_id);
		
		$data = '';
		$line = 0;
		if(file_exists($device->serial))
		{
			$data = file($device->serial);
			$line = $data[count($data)-1];
		}
		$data = explode(',',$line);
		$chart_height += $channels->num_rows()*30;
		
		foreach($channels->result() as $channel)
		{ 
		    $x = 0; 
			$maxrow = 0; 
			if($channel->ctype == 1)
			{
				$cNum = 32 + $channel->chnum;
			}
			else if($channel->ctype == 2)
			{
				$cNum = 40 + $channel->chnum;
			}
			else if ($channel->ctype == 3)
			{
				if($device->type == "geye")
				{
					$cNum = 45;
				}
				else
				{
					$cNum = 8;	
				}
			}
			else {
				$cNum = $channel->chnum;
			}
			
			if(!isset($data[$cNum]))
			{
				$data[$cNum] = 0;					
			}
			
			if($channel->ctype == 1)
			{
				$chanGraph .= '<tr style="height:27px;"><td>'.$channel->channel_name.'</td><td>'.$data[$cNum].'</td><td>'.round($channel->watt,3).'</td></tr>';
			}
			else if($channel->ctype != 3)
			{
				$chanGraph .= '<tr style="height:27px;"><td>'.$channel->channel_name.'</td><td>'.$data[$cNum].'</td><td>'.round($channel->kwh,3).'</td></tr>';	
			}
			else
			{
				$chanGraph .= '<tr style="height:27px;"><td>'.$channel->channel_name.'</td><td>'.round($channel->tmp,2).'</td></tr>';
			}
	        
		
		}
	     
	}

	$chanGraph .= "</table>";
	
	if($dev_id == 0)
	{
		$dev = $this->device_model->getDevices();
	}
	else
	{
		$dev = $this->device_model->getSerial($dev_id);
	}
	
	$data['chnData'] = $chanGraph."</table>";
	$data['chart_height'] = $chart_height;
	$data['dev'] = $dev->row_array();
	$data['dev_id'] = $dev_id;

    $this->load->view('home/loads/live', $data);
  }

   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function getLive($dev_id = 0)
  {
  	$sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
    $theDate = date("Y-m-d",time());
	$userTimezone = new DateTime($theDate, new DateTimeZone($sys['timezone']));
  	$offset = $userTimezone->getOffset();
	
    $begin = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m") , (date("d")-1), date("Y")));
   	$end = date('Y-m-d H:i:s', strtotime('+24 hours', strtotime($begin)));
	
	$chanGraph = '<table id="Table" style="width:400px;"><tr>
		    	<th>Channel Name</th>
		    	<th>Watts</th>
		    	<th>Todays kWh</th>
			</tr>';
	if($dev_id == 0)
	{
		$dev = $this->device_model->getDevices();
	}
	else
	{
		$dev = $this->device_model->getSerial($dev_id);
	}
	$chart_height = 0;
	foreach($dev->result() as $device)
	{
		$channels = $this->minute_model->GetSumPowerReal($begin, $end, $dev_id);
		
		$data = '';
		$line = 0;
		if(file_exists($device->serial))
		{
			$data = file($device->serial);
			$line = $data[count($data)-1];
		}
		$data = explode(',',$line);
		$chart_height += $channels->num_rows()*30;
		
		foreach($channels->result() as $channel)
		{ 
		    $x = 0; 
			$maxrow = 0; 
			if($channel->ctype == 1)
			{
				$cNum = 32 + $channel->chnum;
			}
			else if($channel->ctype == 2)
			{
				$cNum = 40 + $channel->chnum;
			}
			else if ($channel->ctype == 3)
			{
				if($device->type == "geye")
				{
					$cNum = 45;
				}
				else
				{
					$cNum = 8;	
				}
			}
			else {
				$cNum = $channel->chnum;
			}
			
			if(!isset($data[$cNum]))
			{
				$data[$cNum] = 0;					
			}
			
			if($channel->ctype == 1)
			{
				$chanGraph .= '<tr style="height:27px;"><td>'.$channel->channel_name.'</td><td>'.$data[$cNum].'</td><td>'.round($channel->watt,3).'</td></tr>';
			}
			else if($channel->ctype != 3)
			{
				$chanGraph .= '<tr style="height:27px;"><td>'.$channel->channel_name.'</td><td>'.$data[$cNum].'</td><td>'.round($channel->kwh,3).'</td></tr>';	
			}
			else
			{
				$chanGraph .= '<tr style="height:27px;"><td>'.$channel->channel_name.'</td><td>'.$data[$cNum].'</td></tr>';
			}
	        
		
		}
	     
	}

	$chanGraph .= "</table>";
	echo $chanGraph;
  }
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function GraphLive($dev_id = 0)
  {
  	$sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
    $theDate = date("Y-m-d",time());
	$userTimezone = new DateTime($theDate, new DateTimeZone($sys['timezone']));
  	$offset = $userTimezone->getOffset();
    $begin = gmdate('Y-m-d H:i:s');
   	$end = date('Y-m-d H:i:s', strtotime('-3 minutes', strtotime($begin)));
	$chanGraph = "";
	if($dev_id == 0)
	{
		$dev = $this->device_model->getDevices();
	}
	else
	{
		$dev = $this->device_model->getSerial($dev_id);
	}
	$chart_height = 0;
	foreach($dev->result() as $device)
	{
		$channels = $this->minute_model->GetSumPowerReal($end, $begin, $dev_id);
		
		$data = '';
		$line = 0;
		if(file_exists($device->serial))
		{
			$data = file($device->serial);
			$line = $data[count($data)-1];
		}
		$data = explode(',',$line);
		$chart_height += $channels->num_rows()*30;
		$first = true;
		foreach($channels->result() as $channel)
		{ 
		    $x = 0; 
			$maxrow = 0; 
			if($channel->ctype == 1)
			{
				$cNum = 32 + $channel->chnum;
			}
			else if($channel->ctype == 2)
			{
				$cNum = 40 + $channel->chnum;
			}
			else if ($channel->ctype == 3)
			{
				if($device->type == "geye")
				{
					$cNum = 45;
				}
				else
				{
					$cNum = 8;	
				}
			}
			else {
				$cNum = $channel->chnum;
			}
			
			if(!isset($data[$cNum]))
			{
				$data[$cNum] = 0;					
			}
			
			
		    if(!$first)
			{
				$chanGraph .= ',';
			}
			else
			{
				$first = FALSE;	
			}
	        $chanGraph .= '{"ch_name":"'.$channel->channel_name.'", "value":'.round($data[$cNum],2).', "colour":"#'.$channel->colour.'"}';
		
		}
	    $data['html']  = '['.$chanGraph.']';
	}
    $this->load->view('graphs/index', $data);
  }  
  
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function GraphLine($dev_id, $day)
  {
    $sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
    $theDate = date("Y-m-d",time());
	$userTimezone = new DateTime($theDate, new DateTimeZone($sys['timezone']));
  	$offset = $userTimezone->getOffset();
    
    $format = 'g:i a';
    $begin = gmdate('Y-m-d H:i:s', mktime(23, 59, 59, date("m") , (date("d")-1-+$day), date("Y")));
   	$end = date('Y-m-d H:i:s', strtotime('+24 hours', strtotime($begin)));
 	
	$genIndex = strtotime($begin)+1-60;
    $dateArray = $this->_getMinutes($begin,$end);
	
    $first = TRUE;
    
	if($dev_id != 0)
	{
    	$channels = $this->channels_model->getDeviceChannels($dev_id, 0);
	}
	else
	{
		$channels = $this->channels_model->getChannels();
	}
	
	
	$info = $this->minute_model->graphLine($channels, $begin, $end);
	$channels->free_result();

    foreach($info->result() as $result => $v)
    {
	  $index = ((strtotime($v->date)-$genIndex)/60)-1;
	  
	  if($v->ctype != 1)
	  {
	  	$val = $v->watt;
	  }
	  else
	  {
	  	$val = $v->kwh;		
	  }
	  
	  if(!isset($data[$index]))
	  {
		 $data[$index] = ' "'.$v->channel_name.'": '.$val;
	  }
	  else
	  {
	     $data[$index] .= ', "'.$v->channel_name.'": '.$val;
	  }
    }
	
	$info->free_result();
	
    $first = TRUE;
	$x = 0;
	echo '[';
	foreach($dateArray as $value)
    {
      if(!$first)
	  {
	  	echo ', ';
	  }
	  else {
		  $first = FALSE;
	  }
	  
	  if(isset($data[$x]))
	  {
      	echo '{ "date": "'.date($format,$value).'", '.$data[$x].' }';
	  }
	  else
	  {
	  	echo '{ "date": "'.date($format,$value).'" }';
	  }
      $x++;
    }
	echo ']';
  }
	
   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function GetChannelsInfo($dev_id, $day)
  {
  	$sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    
    date_default_timezone_set($sys["timezone"]);
	
    $date = '"title":"'.date('l, F j, Y', mktime(0, 0, 0, date("m") , (date("d")-$day), date("Y"))).'"';
	
	if($dev_id != 0)
	{
    	$channels = $this->channels_model->getDeviceChannels($dev_id);
	}
	else
	{
		$channels = $this->channels_model->getChannels();
	}

    $a = 1;
    $type = '';
	$data = "";
	$side = "";
	$grph = "";
	$chnames = '';
	$first = TRUE;
	$temp = FALSE;
	$pulse = FALSE;
	$watt = FALSE;
	
	foreach($channels->result() as $channel)
    {
      $chinfo = $this->channels_model->getChannelInfo($channel->channel_id);
      $chinfo = $chinfo->row_array();
	  
	  if(!$first)
	  {
	  	$type .= ', ';
	  	$data .= ", ";
	  	$side .= ", ";
		$chnames .= '<n>';
		$grph .= ",";
	  }
      else {
 		$first = FALSE;
	  }
	  
	  $chnames .= $chinfo['channel_name'];
	  $data .= '"'.$chinfo['channel_name'].'_col": "#'.$chinfo['colour'].'"';
	  
      	if($chinfo['ctype'] == 1)
		{
			$temp = TRUE;
			$side .= '"'.$chinfo['channel_name'].'_side": "valueAxis2"';
			$type .= '"'.$chinfo['channel_name'].'_val": "C"';
			$grph .= '"'.$chinfo['channel_name'].'_type": "smoothedLine"';
		}
		else if($chinfo['ctype'] == 2)
		{
			$pulse = TRUE;
			$type .= '"'.$chinfo['channel_name'].'_val": "'.$chinfo['pulse_unit'].'"';
			$side .= '"'.$chinfo['channel_name'].'_side": "valueAxis3"';
			$grph .= '"'.$chinfo['channel_name'].'_type": "line"';
		}
		else {
			$watt = TRUE;
			$type .= '"'.$chinfo['channel_name'].'_val": "Watts"';
			$side .= '"'.$chinfo['channel_name'].'_side": "valueAxis"';
			$grph .= '"'.$chinfo['channel_name'].'_type": "line"';
		}
    }
	
	header("Content-type: text/javascript");
	echo '[{'.$date.','.$data.','.$type.','.$side.','.$grph.',"chnames":"'.$chnames.'"}]';
	die;
  }	

   // --------------------------------------------------------------------

   /**
	* Process ECM-1240 packet
	*
	* @access	public
	* @return	void
	*/
  function _getMinutes($sStartDate, $sEndDate){  
	$sysinfo = $this->sysinfo_model->getInfo();
    $sys = $sysinfo->row_array();
    $theDate = date("Y-m-d",time());
	$userTimezone = new DateTime($theDate, new DateTimeZone($sys['timezone']));
  	$offset = $userTimezone->getOffset();
  	$sStartDate = strtotime(date("Y-m-d H:i:00", strtotime($sStartDate) + $offset));  
 	$sEndDate = strtotime(date("Y-m-d H:i:00", strtotime($sEndDate) + $offset));  
  
	$x = 0;
	$sCurrentDate = $sStartDate;  
	while($sCurrentDate < $sEndDate){  
	
	    $sCurrentDate = $sCurrentDate+60;  

	    // Add this new day to the aDays array  
	    $aDays[] = $sCurrentDate;
		$x++;  
	}  
		// Some code happens here
	  // Once the loop has finished, return the  
	  // array of days.  
	  return $aDays;  
  }  
}