<?php
class Channels_model extends CI_Model {

  function Channels_model()
  {
    parent::__construct();
	$this->load->database('default', true);
  }
  
  function getChannels()
  {
    $this->db->select('channel_id, channel_name, netchannel_id, colour, hide');
	$this->db->order_by('channel_id', 'ASC');
    return $this->db->get('channel');
  }
  
  function checkNegatives($channel_id)
  {
    $this->db->select('channel_name');
	$this->db->where('channel_id = '.$channel_id.' AND (netchannel_id > 0 OR ctype = 1)');
    return $this->db->get('channel');
  }
  
  function getGreenPulses($dev, $chnum = 0)
  {
    $this->db->select('channel_id, pulse, pulse_unit, channel_name, hide, netchannel_id, colour, views');
	$this->db->where('device_id',$dev);
	if($chnum != 0)
	{
		$this->db->where('chnum', $chnum);
	}
	$this->db->where('ctype = 2');
	$this->db->order_by('chnum');
    return $this->db->get('channel');
  }
  
  function getTemp($dev, $chnum = 0)
  {
    $this->db->select('channel_id, channel_name, colour, hide, granws, minws, hourws, views, pulse_unit');
	$this->db->where('device_id',$dev);
	if($chnum != 0)
	{
		$this->db->where('chnum', $chnum);
	}
	$this->db->where('ctype = 1');
	$this->db->order_by('chnum');
    return $this->db->get('channel');
  }
  
  function getVirtChannels($dev, $chnum = 0)
  {
    $this->db->select('channel_id, channel_name, colour, hide, granws, minws, hourws, views, pulse_unit');
	$this->db->where('device_id',$dev);
	if($chnum != 0)
	{
		$this->db->where('chnum', $chnum);
	}
	$this->db->where('ctype = 5');
	$this->db->order_by('chnum');
    return $this->db->get('channel');
  }
   
  function getVirtChannel($channel_id)
  {
    $this->db->select('channel_id, channel_name, colour, hide, granws, minws, hourws, views, pulse_unit');
	$this->db->where('ctype','5');
	$this->db->where('channel_id', $channel_id);
    return $this->db->get('channel');
  }	

  function getFirstChannel($device_id = 0)
  {
  	
    $this->db->select('channel_id');
	if($device_id != 0)
	{
		$this->db->where('device_id', $device_id);
	}
	$this->db->where('ctype', 0);
	$this->db->limit(1);
    return $this->db->get('channel');
  }
  
  function getMain()
  {
    $this->db->select('channel_id, channel_name, colour');
    $this->db->where('main',1);
    return $this->db->get('channel');
  }
  
  function getMainDevice($devid)
  {
    $this->db->select('channel_id');
    $this->db->where('main',1);
    $this->db->where('device_id',$devid);
    return $this->db->get('channel');
  }
  
  function UpdateChannel($channel_id, $updateInfo)
  {
    $this->db->where('channel_id', $channel_id);
    $this->db->update('channel', $updateInfo);
  }
  
  function InsertNet($channel_id, $device_id, $channel_name, $main, $chnum, $colour)
  {
    $data = array(
               'main' => $main,
               'channel_name' => $channel_name,
               'pulse' => 0,
               'ctype' => 0,
               'device_id' => $device_id,
               'chnum' => $chnum,
               'netchannel_id' => $channel_id,
               'hide' => 0,
               'views' => 0,
               'colour' => $colour
            );

    $this->db->insert('channel', $data); 
  }
  
   function RemoveNet($channel_id)
  {
  	 $query = $this->getChannelsNet($channel_id);
	 
	 if($query->num_rows() > 0)
	 {
	 	$query = $query->row_array();
	 
	 	$this->db->where('channel_id', $query['channel_id']);
	 	$this->db->delete('channel');
	 }
  }
  
  function RemoveVirtChannel($channel_id)
  {
  	$query = $this->getVirtChannel($channel_id);
	 
	 if($query->num_rows() > 0)
	 {
	 	$query = $query->row_array();
	 
	 	$this->db->where('channel_id', $query['channel_id']);
	 	$this->db->delete('channel');
	 }
  }
  
  function getNetDevice($devid)
  {
    $this->db->select('channel_id, netchannel_id, channel_name, hide, main, colour, views');
    $this->db->where('netchannel_id >', 0);
    $this->db->where('device_id',$devid);
	$this->db->order_by('chnum');
    return $this->db->get('channel');
  }
  
  
  function getGeneratedDevice($devid)
  {
    $this->db->select('channel_id, netchannel_id');
    $this->db->where('netchannel_id >', 0);
    $this->db->where('main', 0);
    $this->db->where('device_id',$devid);
    return $this->db->get('channel');
  }
  
  function getDeviceChannels($devid, $ctype = 10, $hide = -1)
  {
    $this->db->select('channel_id, main, pulse, channel_name, netchannel_id, ctype, views, image, pulse_unit, hide');
    $this->db->where('device_id', $devid);
	
	if($ctype == 0 || $ctype == 5)
	{
		$this->db->where_in('ctype',array(0,5));
	}
	else if($ctype != 10)
	{
		$this->db->where('ctype', $ctype);
	}
	
	if($hide != -1)
	{
		$this->db->where('hide', $hide);
	}
	$this->db->order_by('ctype', 'ASC');
    $this->db->order_by('chnum');
    return $this->db->get('channel');
  }
  
  function getChannelsNet($netmeter_id)
  {
    $this->db->select('channel_id');
    $this->db->where('netchannel_id', $netmeter_id);
    return $this->db->get('channel', 1);
  }
  
  function getECMChannels($devid)
  {
    $this->db->select('channel_id, main, pulse, pulse_unit, channel_name, netchannel_id, colour, hide, views');
    $this->db->where('device_id', $devid);
    $this->db->where('netchannel_id', 0);
	$this->db->where('ctype < 3');
    $this->db->order_by('chnum');
    return $this->db->get('channel');
  }
  
  function getNoNetChannels($devid)
  {
    $this->db->select('channel_id, main, pulse, pulse_unit, channel_name, netchannel_id, colour, hide, views');
    $this->db->where('device_id', $devid);
    $this->db->where('netchannel_id', 0);
	$this->db->where('ctype',0);
    $this->db->order_by('chnum');
    return $this->db->get('channel');
  }

  function getAllChannels()
  {
    $this->db->select('channel_id, main, pulse, pulse_unit, channel_name, netchannel_id, colour, hide');
    $this->db->where('netchannel_id', 0);
	$this->db->where('ctype',0);
    $this->db->order_by('chnum');
    return $this->db->get('channel');
  }

  function getVoltage($devid)
  {
    $this->db->select('channel_id, main, pulse, pulse_unit, channel_name, netchannel_id, colour, hide');
    $this->db->where('device_id', $devid);
    $this->db->where('netchannel_id', 0);
	$this->db->where('ctype',3);
    $this->db->order_by('chnum');
    return $this->db->get('channel');
  }
  
  function getChannel($devid, $chnum)
  {
    $this->db->select('channel_id, pulse');
	$this->db->from('channel');
    $this->db->join('devices', 'channel.device_id = devices.device_id', 'inner');
    $this->db->where('devices.device_id', $devid);
    $this->db->where('chnum', $chnum);
    $this->db->where("(type != 'geye' AND (pulse != 1 OR ctype != 2))");
    return $this->db->get();
  }
  
  
  function getGChannel($devid, $chnum)
  {
    $this->db->select('channel_id, pulse');
	$this->db->from('channel');
    $this->db->join('devices', 'channel.device_id = devices.device_id', 'inner');
    $this->db->where('devices.device_id', $devid);
    $this->db->where('chnum', $chnum);
    return $this->db->get();
  }
  
  function getChannelInfo($chid)
  {
    $this->db->select('device_id, chnum, channel_name, colour, pulse_unit, ctype, image');
    $this->db->where('channel_id', $chid);
    return $this->db->get('channel');
  }
  
  function getChannelNum($chid)
  {
    $this->db->select('chnum');
    $this->db->where('channel_id', $chid);
    return $this->db->get('channel');
  }
    
  function insertChannel($chalias, $devid, $chnum, $netchid, $colour, $pulse, $ctype = 0)
  {
  	
	if($ctype != 1)
	{
	    $data = array(
	               'main' => 0,
	               'channel_name' => $chalias,
	               'pulse' => $pulse,
	               'device_id' => $devid,
	               'chnum' => $chnum,
	               'colour' => $colour,
	               'ctype' => $ctype,
	               'netchannel_id' => $netchid,
	               'views' => 0
	            );
	}
	else
	{
		$data = array(
	               'main' => 0,
	               'channel_name' => $chalias,
	               'pulse' => $pulse,
	               'device_id' => $devid,
	               'chnum' => $chnum,
	               'colour' => $colour,
	               'ctype' => $ctype,
	               'netchannel_id' => $netchid,
	               'pulse_unit' => "C",
	               'views' => 0
	            );
	}
    $this->db->insert('channel', $data); 
  }
  
  function channelSearch($channel_name)
  {
    $this->db->select('channel_id, channel_name, image, views, ctype, pulse_unit, hide');
    $this->db->where('hide',0);
    $this->db->like('lower(channel_name)', $channel_name);
	$this->db->order_by('ctype', 'ASC');
	$this->db->order_by('channel_id', 'ASC');
    return $this->db->get('channel');
  }
    

  function updateViews($chan_id)
  {
    $this->db->select('views');
    $this->db->where('channel_id', $chan_id);
    $query = $this->db->get('channel',1);
    $query = $query->row_array();
    
    $views = $query['views']+1;
    
    $this->db->set('views',$views);
    $this->db->where('channel_id', $chan_id);
    $this->db->update('channel');
  }
  
  function getChannelsCost()
  {
    $this->db->select('channel_id, channel_name, colour');
    $this->db->where('main',0);
    $this->db->where('netchannel_id',0);
    $this->db->where('pulse',0);
    return $this->db->get('channel');
  }
  
  function getMainNet()
  {
  	$this->db->select('channel_id, channel_name, colour');
    $this->db->where('main',1);
    $this->db->where('netchannel_id >',0);
    return $this->db->get('channel');
  }
  
   function getNoMainNet()
  {
  	$this->db->select('channel_id, channel_name, colour');
    $this->db->where('main',0);
    $this->db->where('netchannel_id >',0);
    return $this->db->get('channel');
  }
  
  function GetChannelsDevices()
  {
    $this->db->select('channel.channel_id, channel.channel_name, devices.serial, devices.alias');
    $this->db->from('channel');
    $this->db->join('devices', 'channel.device_id = devices.device_id', 'inner'); 
	$this->db->order_by('channel.device_id', 'ASC');
	$this->db->order_by('channel.channel_id', 'ASC');
    return $this->db->get();
  }
  
  function UpdateImage($channel_id, $image_name)
  {
  	$this->db->set('image', $image_name);
	$this->db->where('channel_id', $channel_id);
	$this->db->update('channel');
  }

  function ClearData()
  {
  	$this->db->truncate('channel');
  }
}
?>
