<?php
class Device_model extends CI_Model {

  function Device_model()
  {
    parent::__construct();
	$this->load->database('default', true);
  }

  function getDevices($type = '', $option = 0)
  {
    $this->db->select('device_id, serial, net, type, alias');
    
    if($option == 1 && $type != '')
	{
		$this->db->where('type !=', $type);
	}
	else if($type != '')
    {
      $this->db->where('type', $type);
    }
	$this->db->order_by('device_id');
    $query = $this->db->get('devices');
    
    return $query;
  }
  
  function getDevice($serial)
  {
    $this->db->select('device_id, serial, net, type, alias, mindate, hourdate, grandate');
    $this->db->where('serial',$serial);
    $query = $this->db->get('devices');
    
    return $query;
  }
  
  function getSerial($device_id)
  {
    $this->db->select('device_id, serial, net, type, alias');
    $this->db->where('device_id',$device_id);
    $query = $this->db->get('devices');
    
    return $query;
  }
  
  function DeleteDevice($serial)
  {
  	$this->db->select('device_id');
  	$this->db->where('serial', $serial);
	$dev = $this->db->get('devices');
	$dev = $dev->row_array();
	
	$this->db->select('channel_id');
	$this->db->where('device_id',$dev['device_id']);
	$channels = $this->db->get('channel');
	
		
	$this->db->where('device_id', $dev['device_id']);
	$this->db->delete('channel');
	
  	$this->db->where('serial', $serial);
	$this->db->delete('devices');
  }
  
  function InsertDevice($serial, $type)
  {
  	$data = array(
               'serial' => $serial,
               'type' => $type
            );

    $this->db->insert('devices', $data); 
  }

  function InsertVirtualDevice($alias)
  {
  	$data = array(
               'serial' => '9999999',
               'type' => 'virtual',
               'alias' => $alias
            );

    $this->db->insert('devices', $data); 
  }

  function UpdateDevice($devdata, $devid)
  {
    
    $this->db->where('device_id', $devid);
    $this->db->update('devices', $devdata);
    
    if ($this->db->affected_rows() == '1')
    {
      return TRUE;
    }
    
    return FALSE;
  }
  
  
  function deleteDevices()
  {
  	$this->db->delete('devices');
  }
  
  function ClearData()
  {
  	$this->db->truncate('devices');
  }
  
  function getLastLogged($begin, $end)
  {
  	$this->db->select('serial, grandate');
    $this->db->where("grandate BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
	$this->db->order_by("serial", 'DESC');
    return $this->db->get('devices');
  }
}
?>