<?php
class Hour_model extends CI_Model {

  function Hour_model()
  {
    parent::__construct();
	$this->load->database('default', true);
  }

  function getPower ($begin, $end, $channelid, $limit = 0)
  {
    $this->db->select('kwh, watt, cost');
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    $this->db->where("channel_id",$channelid);
    $this->db->order_by("hour_id", "desc");
    if($limit == 1)
    {
      $this->db->limit(1);
    }
    $query = $this->db->get('hourdata');
    
    return $query;
  }
  
  function getSumPower ($begin, $end, $channelid)
  {
    $this->db->select('sum(kwh) as kwh, avg(kwh) as tmp, avg(watt) as watt, sum(totalcost) as totalcost, min(watt) as minwatt, max(watt) as maxwatt');
    $this->db->join('channel', 'channel.channel_id = hourdata.channel_id', 'inner');  
    $this->db->where("channel.channel_id",$channelid);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    return $this->db->get('hourdata');
  }
  
  function getTotalCost ($begin, $end, $channels, $groups = 0)
  {
  	$first = TRUE;
	$sql = 'SELECT channel_name, colour, totalcost FROM (';
  	foreach($channels->result() as $channel)
	{
		if(!$first)
		{
			$sql .= ' UNION ALL ';
		}
		else
		{
			$first = FALSE;
		}
		
		$sql .= "(SELECT channel.channel_name, sum(totalcost) as totalcost, channel.colour
				FROM hourdata 
				INNER JOIN channel ON channel.channel_id = hourdata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND channel.channel_id = ".$channel->channel_id."
				GROUP BY channel.channel_name, channel.colour)";
	}
	
	$sql .= ') tbl ORDER BY totalcost DESC';
	
    $query = $this->db->query($sql);
    return $query;
  }
  

  function getKwhColumn ($begin, $end, $channels)
  {
  	$first = TRUE;
    $sql = 'select kwh, channel_name, colour, ctype  FROM (';
  	foreach($channels->result() as $channel)
	{
		if(!$first)
		{
			$sql .= ' UNION ALL ';
		}
		else
		{
			$first = FALSE;
		}
		
		$sql .= "(SELECT channel.channel_name, sum(kwh) as kwh, channel.colour, channel.ctype
				FROM hourdata 
				INNER JOIN channel ON channel.channel_id = hourdata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND channel.channel_id = ".$channel->channel_id."
				GROUP BY channel.channel_name, channel.colour, channel.ctype)";
	}
	
	
	$sql .= ') tbl ORDER BY kwh DESC';
    $query = $this->db->query($sql);
    return $query;
  }  

  function chkHour($channel_id, $limit = 1)
  {
  	$this->db->select('wattsecond, seconds, date');
  	$this->db->where('channel_id', $channel_id);
	$this->db->order_by('date', 'DESC');
	return $this->db->get('hourdata',$limit);
  }
  
  function getMainPower($begin, $end)
  {
  	$this->db->select('sum(kwh) as kwh, avg(watt) as watt, sum(totalcost) as totalcost, min(watt) as minWatt, max(watt) as maxWatt');
    $this->db->join('channel', 'channel.channel_id = hourdata.channel_id', 'inner');  
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
	$this->db->where('main',1);
    return $this->db->get('hourdata');
  }
  
  function getFirstHour($channel_id, $date, $format = "")
  {
  	if($channel_id == 0)
	{
	    $this->load->model('channels_model');
	    $mains = $this->channels_model->getMain();
		$x = 1;
	    foreach($mains->result() as $main)
	    {
	      if($x == 1)
	      {
	        $where = '(channel_id = '.$this->db->escape($main->channel_id);
	        $x = 0; 
	      }
	      else
	      {
	        $where .= ' OR channel_id = '.$this->db->escape($main->channel_id);
	      }
	    }
	    
	    $where .= ')';
	    
	    $this->db->where($where, NULL, FALSE);
	}
	else
	{
		$this->db->where('channel_id', $channel_id);
	}

	if($format == "")
	{
  		$this->db->select('wattsecond, seconds, date');
	}
	else {
		$this->db->select('max(wattsecond) as wattsecond, max(seconds) as seconds, max(date) as date');
	}
	$this->db->where('date >', $date);
	$this->db->order_by('date', 'ASC');
	if($format != "")
	{
    	$this->db->group_by("DATE_FORMAT(date, ".$this->db->escape($format).")", FALSE);
	}

	return $this->db->get('hourdata',2);
  }
  
  function getLastHour($channel_id, $date, $format = "")
  {
  	if($channel_id == 0)
	{
	    $this->load->model('channels_model');
	    $mains = $this->channels_model->getMain();
		$x = 1;
	    foreach($mains->result() as $main)
	    {
	      if($x == 1)
	      {
	        $where = '(channel_id = '.$this->db->escape($main->channel_id);
	        $x = 0;
	      }
	      else
	      {
	        $where .= ' OR channel_id = '.$this->db->escape($main->channel_id);
	      }
	    }
	    
	    $where .= ')';
	    
	    $this->db->where($where, NULL, FALSE);
	}
	else
	{
		$this->db->where('channel_id', $channel_id);
	}

	if($format == "")
	{
  		$this->db->select('wattsecond, seconds, date');
	}
	else {
		$this->db->select('min(wattsecond) as wattsecond, min(seconds) as seconds, min(date) as date');
	}
	$this->db->where('date <=', $date);
	$this->db->order_by('date', 'DESC');
	if($format != "")
	{
    	$this->db->group_by("DATE_FORMAT(date, ".$this->db->escape($format).")", FALSE);
	}
	
	return $this->db->get('hourdata',1);
  }

  function getSumKwh ($begin, $end, $channelid)
  {
    $this->db->select('sum(kwh) as kwh');
    $this->db->where("channel_id",$channelid);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    return  $this->db->get('hourdata');
  }  

  function insertHour ($ws, $watt, $kwh, $sec, $cost, $totCost, $chid)
  {
    $date = gmdate('Y-m-d H:00:00');
		
	$this->db->select('hour_id');
	$this->db->where('date', $date);
	$this->db->where('channel_id', $chid);
	$query = $this->db->get('hourdata');    
    $return = 0;
	if($query->num_rows() == 0)
	{
      $data = array(
               'channel_id' => $chid ,
               'date' => $date ,
               'wattsecond' => $ws,
               'watt' => $watt,
               'kwh' => $kwh,
               'seconds' => $sec,
               'cost' => $cost,
               'totalcost' => $totCost
            );
            
      $this->db->insert('hourdata', $data);    
      $return = 1;
	}
	return $return;
  }
  
  function getReadingsForLog($date, $devid, $ctype = 0)
  {
    $this->db->select('wattsecond, seconds, date, channel.channel_id, channel.pulse');
	$this->db->from('hourdata');
	$this->db->join('channel', 'hourdata.channel_id = channel.channel_id');
    $this->db->where('date', $date);
    $this->db->where('channel.device_id', $devid);
    $this->db->where('channel.ctype', "0");
    $this->db->where('channel.netchannel_id', "0");
    $this->db->order_by('channel.chnum', 'ASC');
    return $this->db->get();
  }
  
  function getReading ($chid, $date)
  {
    $this->db->select('wattsecond, seconds, date');
    $this->db->where('date <=', $date);
    $this->db->where('channel_id', $chid);
    $this->db->order_by('date','desc');
    $this->db->limit(1);
    return $this->db->get('hourdata');
  }
  
  function fillGraphLoad($cid, $date, $loc, $format)
  {
    $this->db->select('sum(kwh) as kwh', FALSE);
    $this->db->select('max(watt) as watt', FALSE);
    $this->db->select("DATE_FORMAT(max(date), ".$this->db->escape($format).") as date", FALSE);
	if($loc == 0)
	{
    	$this->db->where("date >= ".$this->db->escape($date));
	}
	else {
		$this->db->where("date <= ".$this->db->escape($date));
	}
    $this->db->where("channel_id",$cid);
    $this->db->group_by("DATE_FORMAT(date, ".$this->db->escape($format).")", FALSE);
	if($loc == 0)
	{
		$this->db->order_by("DATE_FORMAT(max(date), ".$this->db->escape($format).")",'ASC');
	}
	else {
		$this->db->order_by("DATE_FORMAT(max(date), ".$this->db->escape($format).")",'DESC');
	}
    return $this->db->get('hourdata',1);
	
  }

  
  function fillGraphMain($date, $loc, $format)
  {
    $this->load->model('channels_model');
    $mains = $this->channels_model->getMain();
    
    $this->db->select('sum(kwh) as kwh', FALSE);
    $this->db->select('sum(watt) as watt', FALSE);
    $this->db->select("DATE_FORMAT(max(date), ".$this->db->escape($format).") as date", FALSE);
	if($loc == 0)
	{
    	$this->db->where("date >= ".$this->db->escape($date));
	}
	else {
		$this->db->where("date <= ".$this->db->escape($date));
	}
    $x = 1;
    
    foreach($mains->result() as $main)
    {
      if($x == 1)
      {
        $where = '(channel_id = '.$this->db->escape($main->channel_id);
        $x = 0;
      }
      else
      {
        $where .= ' OR channel_id = '.$this->db->escape($main->channel_id);
      }
    }
    
    $where .= ')';
    
    $this->db->where($where, NULL, FALSE);
    $this->db->group_by("DATE_FORMAT(date, ".$this->db->escape($format).")", FALSE);
	$this->db->order_by('date','ASC');
    $query = $this->db->get('hourdata',1);
    
    return $query;
  }

  function graphLoad($cid, $begin, $end, $format, $ctype = 0)
  {
  	if($ctype == 0)
	{
		$func = "sum";
	}
	else {
		$func = "avg";
	}
	
  	$sql = "SELECT channel_name, ".$func."(kwh) as kwh, ".$func."(watt) as watt, DATE_FORMAT(max(date), ".$this->db->escape($format).") as date
				FROM hourdata 
				INNER JOIN channel ON channel.channel_id = hourdata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND hourdata.channel_id = ".$this->db->escape($cid)." 
				GROUP BY DATE_FORMAT(date, ".$this->db->escape($format)."), channel.channel_id, channel_name
				ORDER BY channel.channel_id, DATE_FORMAT(date, ".$this->db->escape($format).") ASC";
				
	$sql = "SELECT channel_name, kwh, watt, date
				FROM hourdata 
				INNER JOIN channel ON channel.channel_id = hourdata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND hourdata.channel_id = ".$this->db->escape($cid)." 
				ORDER BY channel.channel_id, date ASC";
				
    return $this->db->query($sql);
  }
  
  function graphMain($begin, $end, $format)
  {
    $this->load->model('channels_model');
    $mains = $this->channels_model->getMain();
    
    $this->db->select('kwh', FALSE);
    $this->db->select('watt', FALSE);
    $this->db->select("date", FALSE);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    $x = 1;
    
    foreach($mains->result() as $main)
    {
      if($x == 1)
      {
        $where = '(channel_id = '.$this->db->escape($main->channel_id);
        $x = 0;
      }
      else
      {
        $where .= ' OR channel_id = '.$this->db->escape($main->channel_id);
      }
    }
    
    $where .= ')';
    
    $this->db->where($where, NULL, FALSE);
    $this->db->order_by('date','ASC');
    $query = $this->db->get('hourdata');

    return $query;
  }
  
  function ClearData()
  {
  	$this->db->truncate('hourdata');
  }
  
  function _getHours($sStartDate, $sEndDate){  

  $sStartDate = date("Y-m-d H:00:00", strtotime($sStartDate));  
  $sEndDate = date("Y-m-d H:00:00", strtotime($sEndDate));  
  $sCurrentDate = $sStartDate;  
  while($sCurrentDate < $sEndDate){  

    $sCurrentDate = date("Y-m-d H:00:00", strtotime("+1 hours", strtotime($sCurrentDate)));  
  
    // Add this new day to the aDays array  
    $aDays[] = $sCurrentDate;  
  } 
  
  // Once the loop has finished, return the  
  // array of days.  
    return $aDays;  
  }  
}
?>
