<?php
class Sysinfo_model extends CI_Model {

  function Sysinfo_model()
  {
    parent::__construct();
	$this->load->database('default', true);
  }

  function GetInfo()
  {
  	$this->db->select('sys_id, flat_rate, month_start, holiday, sat, sun, prov, billing_type, locale, timezone');
    return $this->db->get('sysinfo');
  }
  
  function getLocale()
  {
  	$this->db->select('locale');
	return $this->db->get('sysinfo');
  }
  
  function GetEmail()
  {
  	$this->db->select('email');
	return $this->db->get('sysinfo');
  }
  
  function GetBillingInfo()
  {
    $this->db->select('billing_type, flat_rate, month_start, holiday, sat, sun, prov');
    $query = $this->db->get('sysinfo');
    
    return $query;
  }
  
  function UpdateBilling($flat, $start, $billType, $sat = 0, $sun = 0, $holiday = 0, $prov = '')
  {
    $query = $this->getInfo();
    $query = $query->row_array();
    
    $data = array(
               'billing_type' => $billType,
               'flat_rate' => $flat,
               'holiday' => $holiday,
               'month_start' => $start,
               'sat' => $sat,
               'sun' => $sun,
               'prov' => $prov
            );
    $this->db->where('sys_id', $query['sys_id']);
    $this->db->update('sysinfo',$data); 
  }
  
  function UpdateUser($admin_user, $admin_pass, $admin_email)
  {
  	$this->db->select('sys_id');
	$sysInfo = $this->db->get('sysinfo');
	$sysInfo = $sysInfo->row_array();
	
    $salt = substr(hash('sha256', uniqid(rand(), true)), 0, 18);
    
    $data = array(
               'admin_user' => $admin_user,
               'admin_pass' => hash('sha256', $admin_pass.$salt),
               'admin_salt' => $salt,
               'email' => $admin_email
               );
			   
	$this->db->where('sys_id', $sysInfo['sys_id']);
    $this->db->update('sysinfo',$data); 
	
  }
  
  function UpdatePass($admin_pass)
  {
  	$this->db->select('sys_id');
	$sysInfo = $this->db->get('sysinfo');
	$sysInfo = $sysInfo->row_array();
	
    $salt = substr(hash('sha256', uniqid(rand(), true)), 0, 18);
    
    $data = array(
               'admin_pass' => hash('sha256', $admin_pass.$salt),
               'admin_salt' => $salt
               );
			   
	$this->db->where('sys_id', $sysInfo['sys_id']);
    $this->db->update('sysinfo',$data); 
	
  }
  
  function CheckLogin($admin_user, $admin_pass)
  {
  		$this->db->select('admin_salt');
		$this->db->where('admin_user', $admin_user);
		$uInfo = $this->db->get('sysinfo');
		
		if($uInfo->num_rows() > 0)
		{
			$uInfo = $uInfo->row_array();
	
			$this->db->select('admin_user'); 
			$this->db->where('admin_pass', hash('sha256', $admin_pass.$uInfo['admin_salt']));
			$uName = $this->db->get('sysinfo');
			
			if($uName->num_rows() > 0)
			{
				$uName = $uName->row_array();
				if($uName['admin_user'] == $admin_user)
				{
					return true;
				}
			}
		}
		
		return false;
  }
  
  function GetPowerMeter()
  {
  	$this->db->select('powermeter');
	return $this->db->get('sysinfo');
  }
  
  function UpdatePowerMeter($val)
  {
  	$this->db->set('powermeter',$val);
	$this->db->update('sysinfo');
  }

  function UpdateTimeZone($timezone)
  {
    $data = array(
               'timezone' => $timezone
               );
			   
    $this->db->update('sysinfo',$data); 
  }

  function UpdateLocale($locale)
  {
    $data = array(
               'locale' => $locale
               );
			   
    $this->db->update('sysinfo',$data); 
  }
  
  function InsertInfo($locale, $timezone, $username, $pass, $email)
  {
  	$salt = substr(hash('sha256', uniqid(rand(), true)), 0, 18);
    			   
    $data = array(
    		   'locale' => $locale,
               'timezone' => $timezone,
               'billing_type' => 1,
               'flat_rate' => 0.124,
               'holiday' => 0,
               'month_start' => 1,
               'sat' => 0,
               'sun' => 0,
               'prov' => 0,
               'admin_user' => $username,
               'admin_pass' => hash('sha256', $pass.$salt),
               'admin_salt' => $salt,
               'email' => $email,
               'powermeter' => 0
               );
			   
    $this->db->insert('sysinfo',$data); 
  }
}
?>