<?php
/**
 * Dashboard-Lite
 *
 *  Data Logging and Dashbaord for Brultech Energy Monitors
 *
 * @package		Dashboard-Lite
 * @author		Brultech Team
 * @copyright	Copyright (c) 2011 - 2013, Brultech, Inc.
 * @license		btech-license.txt
 * @link		http://brultech.com
 */

// ------------------------------------------------------------------------

/**
 * Displayimages Controller Class
 *
 * @package	Dashboard-Lite
 * @subpackage	Controllers
 * @category	Images
 * @author	Brultech Team
 * @link	http://brultech.com
 */
class Displayimages extends MX_Controller {
   
  /**
   * Constructor
   *
   * @access	public
   */
  function __construct()
  {
	parent::__construct();
    $this->load->model('channelimage_model');
	$this->load->model('channels_model');
    $this->load->helper('url');
    $this->load->helper('form');
    $this->load->library('form_validation');
  }
  
   // --------------------------------------------------------------------

   /**
	* Bring up images to select from, save based on type
	*
	* @access	public
	* @return	void
	*/
  function Main($type, $id, $serial = 0)
  {
    $data['images'] = $this->channelimage_model->GetImages();
	
	$data['type'] = $type;
	$data['id'] = $id;
	$data['serial'] = $serial;
	
	$this->form_validation->set_rules('id', 'ID',  'required|numeric');
    $this->form_validation->set_rules('imageName', 'Image Name',  'min_length[1]|max_length[40]');
   
    
    if($this->form_validation->run() == FALSE)
    {
    	$this->load->view('displayimages', $data);  
	}
	else
	{
		if($type == 1)
		{
			$this->channels_model->UpdateImage(set_value('id'),set_value('imageName'));
			redirect('pages/device/ecm1240/'.$serial);
		}
		else
		{
			$this->channels_model->UpdateImage(set_value('id'),set_value('imageName'));
			redirect('pages/device/geye/'.$serial);
		}
	
	}
	
  }
}